// Thomas Grenier - Creatis

function [gfx]=DParzen_Ec(X,Xi,h)
// Ici (f.g)' = f'.g'  !!!!!!!!!!!
// Xi : echantillon des donnes : matrice
// X  : point o raliser l'estimation
// fx : estimation au point X

PI=3.141592;
[nb_Xi,nb_Dim] = size(Xi); 


// Profile Epanechnikov -derive
function [y]=g_epan(x)
if abs(x) < 1 then
  y = 3/4;
 else
  y = 0;
end
endfunction

SN=0;
gfx=[0 0 0];

for i = 1:nb_Xi,
  x_xi = X  - Xi(i,:);

  dxs = x_xi(1)*x_xi(1)/(h(1)*h(1)) + x_xi(2)*x_xi(2)/(h(2)*h(2));
  dxr = x_xi(3)*x_xi(3)/(h(3)*h(3));
 
  gxs = g_epan( dxs );
  gxr = g_epan( dxr );

  N = gxs*gxr;
  
  gfx = gfx + Xi(i,:)*N;
  
  SN = SN + N;
end

if SN<>0,
    gfx = gfx / SN;
end

endfunction


