// Thomas Grenier - Creatis

function [gfx]=DParzen_G(X,Xi,h)
// Xi : echantillon des donnes : matrice
// X  : point o raliser l'estimation
// fx : estimation au point X

PI=3.141592;
[nb_Xi,nb_Dim] = size(Xi); 


// Profile Gaussien (k)
function [y]=k_gauss(x)
y = exp(-x/2) /sqrt(2*PI);
endfunction

// Profile Gaussien -derive g=-k'
function [y]=g_gauss(x)
y = exp(-x/2) / (2*sqrt(2*PI));
endfunction


SN=[0 0 0];
gfx=[0 0 0];

for i = 1:nb_Xi,
  x_xi = X  - Xi(i,:);

  dxs = x_xi(1)*x_xi(1)/(h(1)*h(1)) + x_xi(2)*x_xi(2)/(h(2)*h(2));
  dxr = x_xi(3)*x_xi(3)/(h(3)*h(3));
 
  kxs = k_gauss( dxs ); 
  kxr = k_gauss( dxr );  
  gxs = g_gauss( dxs );
  gxr = g_gauss( dxr );

  N = [gxs*kxr, gxs*kxr, gxr*kxs];
  
  gfx = gfx + Xi(i,:).*N;
  
  SN = SN + N;
end

for i=1:3,
  if SN(i)<>0,
    gfx(i) = gfx(i) / SN(i);
  end
end

endfunction

