// Thomas Grenier - Creatis

function [gfxs, gfxr]=DParzen_GGnD(Xs, Xr, Xis, Xir, iHs, iHr , trunc)
//     [Yns(j,:) Ynr(j,:)] = DParzen_GGnD(Ys(j,:), Yr(j,:), Ys, Yr, hs,hr, 1);
// Xi : echantillon des données : matrice
// X  : point où réaliser l'estimation
// GG : version Généralisée (n dimensions, spatial en 1 et 2)
// h : parametre d'echelle pas mis au carre !!
// trunc : if <> 0 trunc Gaussian to trunc*sigma (3.sigma -> trunc = 3)
// fx : estimation au point X

PI=3.141592;
NORM_GAUSS = 5.0132565; // (2*sqrt(2*PI));
trunc2 = trunc*trunc;

[nb_Xi,nb_DimS] = size(Xis); 
[nb_Xi,nb_DimR] = size(Xir); 

// Profile Gaussien -derive g=-k'
function [y]=g_gauss(x)
    y = exp(-x/2) / NORM_GAUSS;
endfunction

SN=0;
gfxs=zeros(1,nb_DimS);
gfxr=zeros(1,nb_DimR);

for i = 1:nb_Xi,
    x_xi = Xs  - Xis(i,:);
    d2xs = x_xi*iHs*x_xi';
    x_xi = Xr  - Xir(i,:);
    d2xr = x_xi*iHr*x_xi';
  
  if(trunc == 0 ) then
      gxs = g_gauss( d2xs );
      gxr = g_gauss( d2xr );
      N = gxs*gxr;
      gfxs = gfxs + Xis(i,:)*N;
      gfxr = gfxr + Xir(i,:)*N;
      SN = SN + N;
  end

  if (trunc ~= 0 & d2xs < trunc2 & d2xr < trunc2 ) then
      gxs = g_gauss( d2xs );
      gxr = g_gauss( d2xr );
      N = gxs*gxr;
      gfxs = gfxs + Xis(i,:)*N;
      gfxr = gfxr + Xir(i,:)*N;
      SN = SN + N;
  end
end

if SN~=0,
    gfxs = gfxs  / SN;
    gfxr = gfxr  / SN;
end

endfunction


