// Thomas Grenier - Creatis

function [gfx]=DParzen_Gc(X,Xi,h)
// Xi : echantillon des données : matrice
// X  : point où réaliser l'estimation
// fx : estimation au point X

PI=3.141592;
[nb_Xi,nb_Dim] = size(Xi); 


// Profile Gaussien -derive g=-k'
function [y]=g_gauss(x)
y = exp(-x/2) / (2*sqrt(2*PI));
endfunction


SN=0;
gfx=[0 0 0];
ih1 = 1.0/(h(1)*h(1));
ih2 = 1.0/(h(2)*h(2));
ih3 = 1.0/(h(3)*h(3));
for i = 1:nb_Xi,
  x_xi = X  - Xi(i,:);

  dxs = x_xi(1)*x_xi(1)*ih1 + x_xi(2)*x_xi(2)*ih2;
  dxr = x_xi(3)*x_xi(3)*ih3;
 
  gxs = g_gauss( dxs );
  gxr = g_gauss( dxr );

  N = gxs*gxr;
  
  gfx = gfx + Xi(i,:)*N;
  
  SN = SN + N;
end

if SN<>0,
  gfx = gfx / SN;
end

endfunction


