// Thomas Grenier - Creatis

// Cluster -> filtrage fukunaga
ima =  GenerateurImage( 20) ;

PlotImage( ima);

h= [5 5 20];
nb_Xi = 600 ;

Trunc_Gauss = 3;
nb_it_max_ms = 20;
eps_ms = 0.05;


title('nGBMS');
f_ima = ima;

// Shoot Xi  qui s'appellent Y ...
[nb_X, nb_Y]= size(ima);
Y=[grand( nb_Xi , 1 , 'unf', 1, nb_X ), grand( nb_Xi , 1 , 'unf', 1, nb_Y ), ones(nb_Xi,1)];
for i=1:nb_Xi,
  Y(i,3)= ima( Y(i,1), Y(i,2) );
end

plot(Y(:,1) , Y(:,2), 'b+');
title('nGBMS');

// Sauvegarde des Y
sY = Y;
Yn = Y;
// Estimation du deplacement en position x,y
SumOfMS = 1;
i=0;
while ((i<nb_it_max_ms) & (SumOfMS > eps_ms) )  
  i = i + 1;
  disp('It :'+string(i));
  for j=1:nb_Xi,
    Yn(j,:) = DParzen_GG(Y(j,:), Y, h, Trunc_Gauss);
  end;
  MS = Yn(j,:) - Y(j,:);
  SumOfMS = MS*MS';
  Y = Yn; 
end;  

plot(Y(:,1), Y(:,2), 'w*' );

// Cluster
// simple
Yl = sY( Y(:,1) < 30,: );
Yr = sY( Y(:,1) >= 30,: );

// saddle
SumOfMS = 1;
i=0;
nb_it_max_ms_sad = 20;

h_sad= [5 5 10];
eps_ms_sad = 0.1;
while ((i<nb_it_max_ms_sad) & (SumOfMS > eps_ms_sad) )  
  i = i + 1;
  SumOfMS = 0;
  disp('It :'+string(i));
  
  for j=1:size(Yl,1),
    Ynlr(j,:) = DParzen_GG(Yl(j,:), Yr, h_sad, Trunc_Gauss);
    Ynll(j,:) = DParzen_GG(Yl(j,:), Yl, h_sad, Trunc_Gauss);
  end;
  
  for j=1:size(Yr,1),
    Ynrl(j,:) = DParzen_GG(Yr(j,:), Yl, h_sad, Trunc_Gauss);
    Ynrr(j,:) = DParzen_GG(Yr(j,:), Yr, h_sad, Trunc_Gauss);
  end;
  
  PlotImage( ima );
  plot( Ynrl(:,1), Ynrl(:,2), 'r*')
  plot( Ynlr(:,1), Ynlr(:,2), 'g*')
  plot( Ynll(:,1), Ynll(:,2), 'g+')
  plot( Ynrr(:,1), Ynrr(:,2), 'r+')
  title('nGBMS '+string(i));
  
  MSl = Ynll(j,:) - Yl(j,:);
  MSr = Ynrr(j,:) - Yr(j,:);
  SumOfMS = MSl*MSl' + MSr*MSr';
  Yl = Ynll;
  Yr = Ynrr;
end;  

PlotImage( ima);
plot( Ynrl(:,1), Ynrl(:,2), 'r*')
plot( Ynlr(:,1), Ynlr(:,2), 'g*')
plot( Ynll(:,1), Ynll(:,2), 'g+')
plot( Ynrr(:,1), Ynrr(:,2), 'r+')

