// Thomas Grenier - Creatis

function [fx]=KPlusProchesVoisins(X, Xi, n)
// Xi : echantillon des donnes : matrice
// X  : point o raliser l'estimation
// n : distance au n ieme voisins de X


PI=3.141592;
[nb_Xi, nb_Dim] = size(Xi); 
x_xi = Xi - X;
d_s = sort( x_xi.*x_xi ); // tri dans l'ordre dcroissant !
if nb_Xi - n <1
  rm = d_s( nb_Xi-1);
else rm = d_s( nb_Xi - n ); 
end

// Profile Gaussien
function [y]=k_gauss(x)
y = exp(-x/2) / sqrt(2*PI);
endfunction

// Profile rectangle
function [y]=k_rect(x)
  y=0;
  if(x<1)
    y = 1/2;
  end;
endfunction


fx=0;
for i = 1:nb_Xi,
  dxs = x_xi(i)*x_xi(i)/(rm);
  fx= fx + k_gauss( dxs );
end

fx = fx / (nb_Xi * sqrt(rm));

endfunction



