function [fx]=Parzen_G1D(X,Xi,h)
// Xi : echantillon des données : vecteur (1D ...)
// X  : point où réaliser l'estimation
// fx : estimation au point X


PI=3.141592;
[nb_Xi, nb_Dim] = size(Xi); 


// Profile Gaussien
function [y]=k_gauss(x)
    y = exp(-x/2) / sqrt(2*PI);
endfunction


// Profile Epanechnikov
function [y]=k_epan(x)
if abs(x) < 1 then
    y = 3*(1-x)/4;
else
    y = 0;
end
endfunction

// Profile Rectangle
function [y]=k_rect(x)
if abs(x)>1 then
    y = 0;
else
    y = 1/2 ;
end
endfunction

if (nb_Dim <> 1) then
    disp("probable mistake on Xi: should be n by 1 vector");
end


fx=0;
for i = 1:nb_Xi,
    x_xi = X - Xi(i);
    dx = x_xi*x_xi / ( h * h ) ;
    fx= fx + k_gauss( dx );
end

fx = fx / (nb_Xi * h);

endfunction
